/*
 * Creado por SharpDevelop.
 * Usuario: Daniel Doctor
 * Visita www.ubicuos.com
 * Fecha: 09/04/2008
 * Hora: 11:48 a.m.
 * 
 * 
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace Bresenham
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class frmBresenham : Form
	{
		public Color color;
		private Graphics g;
		private Bitmap bm;
		public frmBresenham()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		void dibujarPixel(int x, int y, Color c){
				bm.SetPixel(x,y,c);
		}
		void lineaBreseham(int xa, int ya, int xb, int yb)
		{
			int dx, dy, x, y, xEnd, p;
			int xIncrement, yIncrement;
			int aux;
			bool mMayor1= false;
			dx = Math.Abs(xa-xb);
			dy = Math.Abs(ya-yb);
			
	// Tratamos casos especiales dx=0,  dy=0 , dx=dy
	if(dx==dy || dx==0 || dy==0){

		int k,steps;
		steps= Math.Max(dx,dy);
		if(xb>xa) xIncrement=1; else xIncrement=-1;
		if(yb>ya) yIncrement=1; else yIncrement=-1;
		if(dx==0) xIncrement=0;
		if(dy==0) yIncrement=0;
		x=xa;
		y=ya;

	
	
		for(k=1;k<=steps;k++){
			x+=xIncrement;
			y+=yIncrement;
			dibujarPixel(x,y,color);
		}
	}
	else{

		if(Math.Abs(dy)>Math.Abs(dx)) { //intercambio x e y para pendientes mayores que 1
			mMayor1=true;
			aux=xa;
			xa=ya;
			ya=aux;
			aux=xb;
			xb=yb;
			yb=aux;
			dx=Math.Abs(xa-xb);
			dy=Math.Abs(ya-yb);
		}
		
		p=2*dy-dx;
		// determinar punto de comienzo

		if( xa>xb){
			// lineas con y decreciente
			if(ya<yb) yIncrement=-1;
			else yIncrement=1;
			x=xb;
			y=yb;
			xEnd=xa;
		}
		else{
			if(ya>yb) yIncrement=-1;
			else yIncrement=1;
			x=xa;
			y=ya;
			xEnd=xb;
		}


		if(mMayor1)		dibujarPixel(y,x,color);
		else 	dibujarPixel(x,y,color);

		while (x<xEnd){
			x++;
			if(p<0) p+=2*dy;
			else{
				y+=yIncrement;
				p+=2*(dy-dx);
			}
		if(mMayor1)		dibujarPixel(y,x,color);
		else 	dibujarPixel(x,y,color);
		}

	}

}

		void MainFormLoad(object sender, EventArgs e)
		{
			g = this.CreateGraphics();
			bm = new Bitmap(this.Width,this.Height);
			color = Color.Red;
		}
	}
}
